unit vrGlobals;

interface

uses Graphics, SysUtils, Forms, Windows,
  Classes, Controls, Dialogs;

CONST SELDIRHELP=112;

type
  PrefRecord = record
  {This is my secret string ? as text?}
  PHiddenString: string[255]; {array [1..256] of Char;}
  PAutoFileOpenRGIndex: Integer;
  PAutoFileOpenName,
  PAutoFileOpenLastSavedName, PAutoFileOpenLastOpenedName,
  PProjectPath, PProjectName,
  PMapsPath, PMapName,
  PDemPath,  PHTFPath,
  PImageryPath, PShapePath, PVRMDatabase,
  PDLGPath, PDXFPath, PTigerPath,  PDotPath, PSDTSPath,
  {PTempMsgname,}
  PProgramPath,
  PVRMProgramPath,   PVectorPath,
  POldFileName4,POldFileName3,POldFileName2,
  POldFileName1,POldFileName0,
  PThumbPath,  PTransSearchDir,
  PILHallPath, PLifePath, PFractal3DPath, PDTMPath,
  PGripPath, PTracerPath,
  PSOSMAPPath, PNoNamePath, PVRGISPath, PVRGISName
  : string[255];
  PMapBordersColor, PMapGridsColor,
  PMapDatasColor, PMapBacksColor: TColor;
  PColorreg: Integer;
  PStarted: TDateTime;
  PFilePreviews,
  PWarningBeepOn,PInfoBeepOn,PConfirmBeepOn,PCompletedBeepOn,
  PSkip32BitNotice,PSkipIntroScreen,PPrintBigChecked,PUseThumbnails,
  PAutoDisPlay, PVoicesON, PDoneBeepOn, PErrorBeepOn, PbAutoSave: Boolean;
  PThumbColor,  PCurrentColor: TColor;
  PThumbSize: Integer;
  PStartedNameNumber: string[25];
  PvrTaskIP0,  PvrTaskIP1,  PvrTaskIP2,  PvrTaskIP3,
  PvrTaskIP4,  PvrTaskIP5,  PvrTaskIP6,  PvrTaskIP7,
  PViewCommanderIPPort,    PRCEHostname: string[15];
  PvrTaskPort0,  PvrTaskPort1,  PvrTaskPort2,  PvrTaskPort3,
  PvrTaskPort4,  PvrTaskPort5,  PvrTaskPort6,  PvrTaskPort7,
  PViewCommanderEPort,PRCEPort: string[5];
  PvrTaskPassword, PRCPasswordEdit: string[255];
  {X Y Location of forms}
  PMainfrmX, PMainfrmY,
  PLaunchFormX,PLaunchFormY,
  PaaProjFormX,PaaProjFormY,
  PViewCommanderFormX,PViewCommanderFormY,
  PRControlFormX,PRControlFormY,
  PProcListFormX,PProcListFormY,
  PFilesFormX,PFilesFormY,
  PAvrTaskConnectFrmX,PAvrTaskConnectFrmY,
  PMessageX,PMessageY,
  PAboutX, PAboutY,
  PPOFFormX, PPOFFormY : Integer;
  end;

  PrefFile = file of PrefRecord;
var
  PreRcd: PrefRecord;
  AutoFileOpenRGIndex: Integer;
  AutoFileOpenName,AutoFileOpenLastSavedName, AutoFileOpenLastOpenedName,
ProjectPath, ProjectName,
MapsPath, MapName,
DemPath,  HTFPath,
ImageryPath, ShapePath, VRMDatabase,
DLGPath, DXFPath, TigerPath,  DotPath, SDTSPath,
  TempMsgname,
  ProgramPath,
VRMProgramPath,   VectorPath,

  OldFileName4,OldFileName3,OldFileName2,
  OldFileName1,OldFileName0, OldPath,

  ThumbPath,  TransSearchDir,
  ILHallPath, LifePath, Fractal3DPath, DTMPath,
  GripPath, TracerPath,
  SOSMAPPath, NoNamePath, VRGISPath, VRGISName,
  HiddenString, StartedNameNumber: string;
    MapBordersColor, MapGridsColor,
    MapDatasColor, MapBacksColor: TColor;
  Colorreg: Integer;
  Started: TDateTime;
  FilePreviews,
  WarningBeepOn,InfoBeepOn,ConfirmBeepOn,CompletedBeepOn,
  Skip32BitNotice,SkipIntroScreen,PrintBigChecked,UseThumbnails,
  AutoDisPlay, VoicesON, DoneBeepOn, ErrorBeepOn, bAutoSave: Boolean;
  ThumbColor,  CurrentColor: TColor;
  ThumbSize: Integer;

  vrTaskIP0,  vrTaskIP1,  vrTaskIP2,  vrTaskIP3,
    vrTaskIP4,  vrTaskIP5,  vrTaskIP6,  vrTaskIP7,
  ViewCommanderIPPort,    RCEHostname: string[15];
  vrTaskPort0,  vrTaskPort1,  vrTaskPort2,  vrTaskPort3,
    vrTaskPort4,  vrTaskPort5,  vrTaskPort6,  vrTaskPort7,
    ViewCommanderEPort,RCEPort: string[5];
    vrTaskPassword,RCPasswordEdit: string[255];

  MainfrmX, MainfrmY,
  LaunchFormX,LaunchFormY,
  aaProjFormX,aaProjFormY,
  ViewCommanderFormX,ViewCommanderFormY,
  RControlFormX,RControlFormY,
  ProcListFormX,ProcListFormY,
  FilesFormX,FilesFormY,
  AvrTaskConnectFrmX,AvrTaskConnectFrmY,

  MessageX,MessageY,
    AboutX, AboutY,
    POFFormX, POFFormY    : Integer;

{  UserID,
    Sample, SampleW,  ServerActiveCount,}
{    BottomRow, TopRow, RightColumn, LeftColumn: Integer;
  dXTemp, dYTemp, dXMIN, dYMIN, dXMAX, dYMAX: Double;}

{pf24bit pf32bit}
 { MyPixelFormat: TPixelFormat;
  PixelScanSize: Byte;
  FileSize: Integer;  }
  MMSysHandle: THandle;
  PlaySound: function(lpszSoundName: PAnsiChar; uFlags: UINT): BOOL;
  stdcall;

procedure DoLoader;
procedure SetPreferences;
procedure DoSaver;
procedure GetPreferences;
procedure DoMessages(Input:Integer);

implementation

procedure DoMessages(Input:Integer);
Begin
{}
End;

procedure DoLoader;
var P_File: PrefFile;
var PathS: string;
begin {}
  PathS := ExtractFilePath(ParamStr(0)) + 'vrgis.pof';
  if FileExists(PathS) then begin
    AssignFile(P_File, PathS);
    Reset(P_File);
    if IoResult <> 0 then
    begin
{        Application.MessageBox}
      ShowMessage
        ('Failed reading vrgis.pof File'
          {,'Open Error',MB_OKCANCEL});
    end;
    Read(P_File, PreRcd);
    CloseFile(P_File);
    SetPreferences;
  end else
        {Application.MessageBox} ShowMessage
      ('vrgis.pof Does NOT Exist' {,'Open Error',MB_OKCANCEL});
end;


procedure SetPreferences;
begin {after loading}
  with PreRcd do begin
  HiddenString:=PHiddenString;
  ProjectPath:=PProjectPath; ProjectName:=PProjectName;
  MapsPath:=PMapsPath; MapName:=PMapName;
  DemPath:=PDemPath;  HTFPath:=PHTFPath;
  ImageryPath:=PImageryPath; ShapePath:=PShapePath;
  VRMDatabase:=PVRMDatabase;
  DLGPath:=PDLGPath; DXFPath:=PDXFPath;
   TigerPath:=PTigerPath;  DotPath:=PDotPath;
    SDTSPath:=PSDTSPath;  {PTempMsgname,}
  ProgramPath:=PProgramPath;
  VRMProgramPath:=PVRMProgramPath;
  VectorPath:=PVectorPath;
  OldFileName4:=POldFileName4;
  OldFileName3:=POldFileName3;
  OldFileName2:=POldFileName2;
  OldFileName1:=POldFileName1;
  OldFileName0:=POldFileName0;
  ThumbPath:=PThumbPath;  TransSearchDir:=PTransSearchDir;
  ILHallPath:=PILHallPath; LifePath:=PLifePath;
  Fractal3DPath:=PFractal3DPath; DTMPath:=PDTMPath;
  GripPath:=PGripPath; TracerPath:=PTracerPath;
  SOSMAPPath:=PSOSMAPPath; NoNamePath:=PNoNamePath;
  VRGISPath:=PVRGISPath; VRGISName:=PVRGISName;

  MapBordersColor:=PMapBordersColor; MapGridsColor:=PMapGridsColor;
  MapDatasColor:=PMapDatasColor; MapBacksColor:=PMapBacksColor;
  Colorreg:=PColorreg;
  Started:=PStarted;
  FilePreviews:=PFilePreviews;
  AutoFileOpenRGIndex:=PAutoFileOpenRGIndex;
  AutoFileOpenName:=PAutoFileOpenName;
  AutoFileOpenLastSavedName:=PAutoFileOpenLastSavedName;
  AutoFileOpenLastOpenedName:=PAutoFileOpenLastOpenedName;
  WarningBeepOn:=PWarningBeepOn;InfoBeepOn:=PInfoBeepOn;
  ConfirmBeepOn:=PConfirmBeepOn;CompletedBeepOn:=PCompletedBeepOn;
  Skip32BitNotice:=PSkip32BitNotice;
  SkipIntroScreen:=PSkipIntroScreen;
  PrintBigChecked:=PPrintBigChecked;
  UseThumbnails:=PUseThumbnails;
  AutoDisPlay:=PAutoDisPlay;
  VoicesON:=PVoicesON; DoneBeepOn:=PDoneBeepOn;
  ErrorBeepOn:=PErrorBeepOn; bAutoSave:=PbAutoSave;
  ThumbColor:=PThumbColor;  CurrentColor:=PCurrentColor;
  ThumbSize:=PThumbSize;
 StartedNameNumber:=PStartedNameNumber;
  vrTaskPort0:=PvrTaskPort0;  vrTaskPort1:=PvrTaskPort1;
  vrTaskPort2:=PvrTaskPort2;  vrTaskPort3:=PvrTaskPort3;
  vrTaskPort4:=PvrTaskPort4;  vrTaskPort5:=PvrTaskPort5;
  vrTaskPort6:=PvrTaskPort6;  vrTaskPort7:=PvrTaskPort7;
  ViewCommanderIPPort:=PViewCommanderIPPort;
  RCEHostname:=PRCEHostname;
  ViewCommanderEPort:=PViewCommanderEPort;
  vrTaskIP0:=PvrTaskIP0;  vrTaskIP1:=PvrTaskIP1;
  vrTaskIP2:=PvrTaskIP2;  vrTaskIP3:=PvrTaskIP3;
  vrTaskIP4:=PvrTaskIP4;  vrTaskIP5:=PvrTaskIP5;
  vrTaskIP6:=PvrTaskIP6;  vrTaskIP7:=PvrTaskIP7;
  RCEPort:=PRCEPort;
  vrTaskPassword:=PvrTaskPassword;
  RCPasswordEdit:=PRCPasswordEdit;
  {X Y Location of forms}
  MainfrmX:=PMainfrmX; MainfrmY:=PMainfrmY;
  LaunchFormX:=PLaunchFormX;LaunchFormY:=PLaunchFormY;
  aaProjFormX:=PaaProjFormX;aaProjFormY:=PaaProjFormY;
  ViewCommanderFormX:=PViewCommanderFormX;
  ViewCommanderFormY:=PViewCommanderFormY;
  RControlFormX:=PRControlFormX;
  RControlFormY:=PRControlFormY;
  ProcListFormX:=PProcListFormX;
  ProcListFormY:=PProcListFormY;
  FilesFormX:=PFilesFormX;
  FilesFormY:=PFilesFormY;
  AvrTaskConnectFrmX:=PAvrTaskConnectFrmX;
  AvrTaskConnectFrmY:=PAvrTaskConnectFrmY;
  MessageX:=PMessageX;MessageY:=PMessageY;
  AboutX:=PAboutX; AboutY:=PAboutY;
  POFFormX:=PPOFFormX; POFFormY :=PPOFFormY;
  end;
end;
{---------------------------------------------------------------------}

procedure DoSaver;
var P_File: PrefFile;
var PathS: string;
begin
  PathS := ExtractFilePath(ParamStr(0)) + 'vrgis.pof';
{       If (Not FileExists(PathS)) THEN
       ShowMessage(PathS+#13#10+
        'Does NOT Exist:... Will Make it');}
{        Started:=Date;}
  GetPreferences;
  AssignFile(P_File, PathS {'ILH.ILH'});
  Rewrite(P_File);
  if IoResult <> 0 then
  begin
{        Application.MessageBox} ShowMessage
      ('Failed writing vrgis.pof File' {,'Open Error',MB_OKCANCEL});
  end;
  write(P_File, PreRcd);
  CloseFile(P_File);
end;
{---------------------------------------------------------------------}

procedure GetPreferences;
begin {before saving}
  with PreRcd do begin
  PHiddenString:=HiddenString;
  PProjectPath:=ProjectPath; PProjectName:=ProjectName;
  PMapsPath:=MapsPath; PMapName:=MapName;
  PDemPath:=DemPath;  PHTFPath:=HTFPath;
  PImageryPath:=ImageryPath; PShapePath:=ShapePath;
  PVRMDatabase:=VRMDatabase;
  PDLGPath:=DLGPath; PDXFPath:=DXFPath;
   PTigerPath:=TigerPath;  PDotPath:=DotPath;
    PSDTSPath:=SDTSPath;  {PTempMsgname,}
  PProgramPath:=ProgramPath;
  PVRMProgramPath:=VRMProgramPath;
  PVectorPath:=VectorPath;
  POldFileName4:=OldFileName4;
  POldFileName3:=OldFileName3;
  POldFileName2:=OldFileName2;
  POldFileName1:=OldFileName1;
  POldFileName0:=OldFileName0;
  PThumbPath:=ThumbPath;  PTransSearchDir:=TransSearchDir;
  PILHallPath:=ILHallPath; PLifePath:=LifePath;
  PFractal3DPath:=Fractal3DPath; PDTMPath:=DTMPath;
  PGripPath:=GripPath; PTracerPath:=TracerPath;
  PSOSMAPPath:=SOSMAPPath; PNoNamePath:=NoNamePath;
  PVRGISPath:=VRGISPath; PVRGISName:=VRGISName;

  PMapBordersColor:=MapBordersColor; PMapGridsColor:=MapGridsColor;
  PMapDatasColor:=MapDatasColor; PMapBacksColor:=MapBacksColor;
  PColorreg:=Colorreg;
  PStarted:=Started;
  PFilePreviews:=FilePreviews;
  PWarningBeepOn:=WarningBeepOn;PInfoBeepOn:=InfoBeepOn;
  PConfirmBeepOn:=ConfirmBeepOn;PCompletedBeepOn:=CompletedBeepOn;
  PSkip32BitNotice:=Skip32BitNotice;
  PSkipIntroScreen:=SkipIntroScreen;
  PPrintBigChecked:=PrintBigChecked;
  PUseThumbnails:=UseThumbnails;
  PAutoDisPlay:=AutoDisPlay;
  PAutoFileOpenRGIndex:=AutoFileOpenRGIndex;
  PAutoFileOpenName:=AutoFileOpenName;
  PAutoFileOpenLastSavedName:=AutoFileOpenLastSavedName;
  PAutoFileOpenLastOpenedName:=AutoFileOpenLastOpenedName;
  PVoicesON:=VoicesON; PDoneBeepOn:=DoneBeepOn;
  PErrorBeepOn:=ErrorBeepOn; PbAutoSave:=bAutoSave;
  PThumbColor:=ThumbColor;  PCurrentColor:=CurrentColor;
  PThumbSize:=ThumbSize;
  PStartedNameNumber:=StartedNameNumber;
  PvrTaskPort0:=vrTaskPort0;  PvrTaskPort1:=vrTaskPort1;
  PvrTaskPort2:=vrTaskPort2;  PvrTaskPort3:=vrTaskPort3;
  PvrTaskPort4:=vrTaskPort4;  PvrTaskPort5:=vrTaskPort5;
  PvrTaskPort6:=vrTaskPort6;  PvrTaskPort7:=vrTaskPort7;
  PViewCommanderIPPort:=ViewCommanderIPPort;
  PRCEHostname:=RCEHostname;
  PViewCommanderEPort:=ViewCommanderEPort;
  PvrTaskIP0:=vrTaskIP0;  PvrTaskIP1:=vrTaskIP1;
  PvrTaskIP2:=vrTaskIP2;  PvrTaskIP3:=vrTaskIP3;
  PvrTaskIP4:=vrTaskIP4;  PvrTaskIP5:=vrTaskIP5;
  PvrTaskIP6:=vrTaskIP6;  PvrTaskIP7:=vrTaskIP7;
  PRCEPort:=RCEPort;
  PvrTaskPassword:=vrTaskPassword;
  PRCPasswordEdit:=RCPasswordEdit;
  {X Y Location of forms}
  PMainfrmX:=MainfrmX; PMainfrmY:=MainfrmY;
  PLaunchFormX:=LaunchFormX;PLaunchFormY:=LaunchFormY;
  PaaProjFormX:=aaProjFormX;PaaProjFormY:=aaProjFormY;
  PViewCommanderFormX:=ViewCommanderFormX;
  PViewCommanderFormY:=ViewCommanderFormY;
  PRControlFormX:=RControlFormX;
  PRControlFormY:=RControlFormY;
  PProcListFormX:=ProcListFormX;
  PProcListFormY:=ProcListFormY;
  PFilesFormX:=FilesFormX;
  PFilesFormY:=FilesFormY;
  PAvrTaskConnectFrmX:=AvrTaskConnectFrmX;
  PAvrTaskConnectFrmY:=AvrTaskConnectFrmY;
  PMessageX:=MessageX;PMessageY:=MessageY;
  PAboutX:=AboutX; PAboutY:=AboutY;
  PPOFFormX:=POFFormX; PPOFFormY :=POFFormY;
  end;
end;
{---------------------------------------------------------------------}

end.
