unit vrLaunchFrm;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus;

type
  TvrLaunchForm = class(TForm)
    Panel1: TPanel;
    LocateBtn: TSpeedButton;
    VRSOSMAPBtn: TSpeedButton;
    OpenDialog1: TOpenDialog;
    DigitizerBtn: TSpeedButton;
    VRGISBtn: TSpeedButton;
    FractalBtn: TSpeedButton;
    RasterBtn: TSpeedButton;
    HoloBtn: TSpeedButton;
    ImageBtn: TSpeedButton;
    DTMBtn: TSpeedButton;
    LifeBtn: TSpeedButton;
    VOICEBtn: TSpeedButton;
    ILHBtn: TSpeedButton;
    TongsBtn: TSpeedButton;
    Label2: TLabel;
    FileNameEdit: TEdit;
    OpenFileBtn: TSpeedButton;
    Param1Edit: TEdit;
    ClearParametersBtn: TSpeedButton;
    Param2Edit: TEdit;
    Param3Edit: TEdit;

    procedure RasterBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DigitizerBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure VRSOSMAPBtnClick(Sender: TObject);
    procedure ImageBtnClick(Sender: TObject);
    procedure LocateBtnClick(Sender: TObject);
    procedure HoloBtnClick(Sender: TObject);
    procedure LifeBtnClick(Sender: TObject);
    procedure FractalBtnClick(Sender: TObject);
    procedure DTMBtnClick(Sender: TObject);
    procedure VRGISBtnClick(Sender: TObject);
    procedure VOICEBtnClick(Sender: TObject);
    procedure ILHBtnClick(Sender: TObject);
    procedure OpenFileBtnClick(Sender: TObject);
    procedure ClearParametersBtnClick(Sender: TObject);
    procedure GetParameters;
  private
    { Private declarations }
    VrParamString:String;          
  end;

var
  vrLaunchForm: TvrLaunchForm;

implementation

{$R *.DFM}

uses FmxUtils, vrGlobals, VrgisProjman;

procedure TvrLaunchForm.FormCreate(Sender: TObject);
begin
  VrParamString:='';
  top := LaunchFormY;
  left := LaunchFormX;
end;

{---------------------------------------------------------------------}

procedure TvrLaunchForm.FormClose(Sender: TObject; var Action:
  TCloseAction);
begin
  LaunchFormX := vrLaunchForm.left;
  LaunchFormY := vrLaunchForm.top;
end;
{---------------------------------------------------------------------}





procedure TvrLaunchForm.VOICEBtnClick(Sender: TObject);
begin    GetParameters;
  if FileExists(VectorPath + 'voice.exe') then
    ExecuteFile('voice.exe', VrParamString, VectorPath, SW_SHOW) else
    ShowMessage('VOICE not found' + #13#10 + VectorPath);
end;

procedure TvrLaunchForm.RasterBtnClick(Sender: TObject);
begin           GetParameters;
  if FileExists(GripPath + 'Grip.EXE') then
    ExecuteFile('Grip.EXE', VrParamString, GripPath, SW_SHOW) else
    ShowMessage('Grip not found' + #13#10 + GripPath);
end;

procedure TvrLaunchForm.DigitizerBtnClick(Sender: TObject);
begin            GetParameters;
  if FileExists(TracerPath + 'Tracer.EXE') then
    ExecuteFile('Tracer.EXE', VrParamString, TracerPath, SW_SHOW) else
    ShowMessage('Tracer not found' + #13#10 + TracerPath);
end;

procedure TvrLaunchForm.VRSOSMAPBtnClick(Sender: TObject);
begin           GetParameters;
  if FileExists(SOSMAPPath + 'SOSMAP.EXE') then
    ExecuteFile('SOSMAP.EXE', VrParamString, SOSMAPPath, SW_SHOW) else
    ShowMessage('SOSMAP not found' + #13#10 + SOSMAPPath);
end;

procedure TvrLaunchForm.ILHBtnClick(Sender: TObject);
begin           GetParameters;
  if FileExists(ILHallPath + 'ilh.exe') then
    ExecuteFile('ilh.exe', VrParamString, ILHallPath, SW_SHOW) else
    ShowMessage('ILH not found' + #13#10 + ILHallPath);
end;

procedure TvrLaunchForm.ImageBtnClick(Sender: TObject);
begin          GetParameters;
  if FileExists(ILHallPath + 'Image.EXE') then
    ExecuteFile('Image.EXE', VrParamString, ILHallPath, SW_SHOW) else
    ShowMessage('Image not found' + #13#10 + ILHallPath);
end;

procedure TvrLaunchForm.LocateBtnClick(Sender: TObject);
begin          GetParameters;
  if FileExists(ILHallPath + 'locatable.EXE') then
    ExecuteFile('locatable.EXE', VrParamString, ILHallPath, SW_SHOW) else
    ShowMessage('Locatable not found' + #13#10 + ILHallPath);
end;

procedure TvrLaunchForm.HoloBtnClick(Sender: TObject);
begin           GetParameters;
  if FileExists(ILHallPath + 'Holo.EXE') then
    ExecuteFile('Holo.EXE', VrParamString, ILHallPath, SW_SHOW) else
    ShowMessage('Holographics not found' + #13#10 + ILHallPath);
end;

procedure TvrLaunchForm.LifeBtnClick(Sender: TObject);
begin          GetParameters;
  if FileExists(LifePath + 'Life.EXE') then
    ExecuteFile('Life.EXE', VrParamString, LifePath, SW_SHOW) else
    ShowMessage('Life not found' + #13#10 + LifePath);
end;

procedure TvrLaunchForm.FractalBtnClick(Sender: TObject);
begin          GetParameters;
  if FileExists(Fractal3DPath + 'Fractal3D.EXE') then
    ExecuteFile('Fractal3D.EXE', VrParamString, Fractal3DPath, SW_SHOW) else
    ShowMessage('Fractal 3D not found' + #13#10 + Fractal3DPath);
end;

procedure TvrLaunchForm.DTMBtnClick(Sender: TObject);
begin         GetParameters;
  if FileExists(DTMPath + 'DTM.EXE') then
    ExecuteFile('DTM.EXE', VrParamString, DTMPath, SW_SHOW) else
    ShowMessage('DTM not found' + #13#10 + DTMPath);
end;

procedure TvrLaunchForm.VRGISBtnClick(Sender: TObject);
begin
  aaProjForm.show;
end;

procedure TvrLaunchForm.OpenFileBtnClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    FileNameEdit.Text:= OpenDialog1.FileName;
end;

procedure TvrLaunchForm.ClearParametersBtnClick(Sender: TObject);
begin
   Param1Edit.Text:='';
   Param2Edit.Text:='';
   Param3Edit.Text:='';
   FileNameEdit.Text:='';
   VrParamString:='';
end;

procedure TvrLaunchForm.GetParameters;
var tempstr1,tempstr2,tempstr3,tempstr4:String;
begin
  tempstr1:=FileNameEdit.Text;
  tempstr2:=Param1Edit.Text;
  tempstr3:=Param2Edit.Text;
  tempstr4:=Param3Edit.Text;
  If length(tempstr1)>0 then tempstr1:='"'+FileNameEdit.Text+'" 'else tempstr1:='_ ';
  If length(tempstr2)>0 then tempstr2:=tempstr2+' ' else tempstr2:='_ ';
  If length(tempstr3)>0 then tempstr3:=tempstr3+' ' else tempstr3:='_ ';
  If length(tempstr4)>0 then tempstr4:=tempstr3+' ' else tempstr4:='_';
  VrParamString:=tempstr1+tempstr2+tempstr3+tempstr4;
  //Filename TaskId# Param Param
  //FindCmdLineSwitch
  //Use double quotes to wrap multiple words as one parameter
  //(such as long file names containing spaces)
  //valid argument-delimiter characters (e.g., "-" and "/" are common delimiters).
                   //  \ is directory in MS DOS
  { ExtractHTTPFields
  HTTPEncode
  HTTPEncode converts all characters in the AStr parameter
  except for the letters A through Z (and a through z),
  numerals 0 through 9, the asterisk (*), dollar sign ($),
  exclamation point (!), at sign (@), period (.), underscore (_),
  single quote (), comma (,) parentheses, and hyphen (-).
  Spaces are converted to plus characters (+),
  and all other characters are converted into
  hex values preceded by the percent sign (%). }

{Command line switches consist of a + (plus) or - (minus) sign,
 followed by one or more alphabetic characters
 and possibly a numeric value.
 Here is a typical command line with switches.
  POVRAY +Isimple.pov +V +W80 +H60
  5.1.2  Using INI Files}
{
Keyword=bool Turn Keyword on if bool equals true, yes, on or 1
             and Turn it off if it is any other value.
Keyword=true Do this option if true, yes, on or 1 is specified. 
Keyword=false Do this option if false, no, off or 0 is specified. 
Keyword=filename Set Keyword to filename where filename is any valid file name. 
Note: some options prohibit the use of any of the above
      true or false values as a file name.
      They are noted in later sections.
 
n Any integer such as in +W320 
n.n Any float such as in Clock=3.45 
0.n Any float < 1.0 even if it has no leading 0 
s Any string of text 
x or y Any single character 
path Any directory name, drive optional,
no final path separator ("\" or "/",
depending on the operating system)
}
{
 Display=bool Turns graphic display on/off 
 +D Turns graphic display on 
 -D Turns graphic display off 
 Video_Mode=x Set video mode to x; does not affect on/off 
+Dx Set display on; Set mode to x 
-Dx Set display off; but for future use mode x 
 Palette=y Set display palette to y; does not affect on/off 
+Dxy Set display on; Set mode x; Set palette y 
-Dxy Set display off; use mode x, palette y in future 
 Display_Gamma=n.n Sets the display gamma to n.n 

The Display=on or +D switch will turn on
the graphics display of the image while it is being rendered.
}

end;

end.
