unit GeoPrimeUnit;

interface

uses   SysUtils,AllGlobalUnit;

function Prime: Integer; stdcall;
function PrimeF1(N:Integer): Integer; stdcall;
function PrimeVerified: Integer; stdcall;
Function Eratosthenes(n:Integer):Integer;

exports
  Prime,PrimeF1,PrimeVerified;

implementation

function Prime: Integer; stdcall;
Begin
  Result:=   {1..7919 the 1000th}
  Eratosthenes(round(random(8000)));
End;

function PrimeF1(N:Integer): Integer; stdcall;
Begin
  Result:=Eratosthenes(N);
End;

function PrimeVerified: Integer; stdcall;
var n,i,ii,j,p:Integer;
a,b:array of integer;
f:textfile;
Begin  {1..7919 the 1000th}
  CurrentErrorStatus:=0;
  CurrentProgress:= 0;
  setlength(b,1001);                   {  GeoPrimes.txt}
  AssignFile(F, Extractfilepath(ParamStr(0))+'GeoPrimes.txt');
  Reset(F);
  for i := 1 to 1000 do Read(F,b[i-1]);
  CloseFile(F);
  for ii := 1 to 999 do {0=2.. skip}
  begin
  n:=b[ii];
  setlength(a,n+1);
  a[0] := 0;a[1] := 0;
  for i := 2 to n do a[i] := 1;
  p := 2;
  while (p*p)  <  n do
  begin
    j := (p*p);
    while (j  <  n) do
    begin
      a[j] := 0;
      j := j+p;
    end;
    repeat p := p+1 until a[p] = 1;
  end;
  If CurrentErrorStatus < 1 then If (p<> b[ii]) then CurrentErrorStatus:=ii;
  end;
  result:=CurrentErrorStatus;//(a[p]);
End;

Function Eratosthenes(n:Integer):Integer;
var I,j,p:Integer;
a:array of integer;
Begin
  CurrentProgress:= 0;
  setlength(a,n+1);
  a[1] := 0;
  for i := 2 to n do a[i] := 1;
  p := 2;
  while (p*p)  <  n do
  begin
    j := (p*p);
    while (j  <  n) do
    begin
      a[j] := 0;
      j := j+p;
      CurrentProgress:= round( (j/n)*100);
    end;
    repeat p := p+1 until a[p] = 1;
  end;
  result:=p;//(a[p]);
End;

end.
