unit VRTaskDroneFrm;
{***************************************************************
 *
 * Project  : VR Server   169.254.126.198  197 .. 200
 * Unit Name: aGripserver
 * Purpose  : Demonstrates sending / receiving record data and use of buffers
 * Version  : 1.0
 * Date     : May 2003
 * Author   : Ivan Lee Herring
 * History  :
 * Tested   : ?
 * Cribbed from: INDY DEMO : Allen O'Neill <allen_oneill@hotmail.com>
 ****************************************************************}

{Vector.dll}{Raster}{Geographic }{Information }{Synthesis}
{VR Task Server (this) calls the ____DLL to process tasks
 DllCount reports back the Number of tasks
    AND writeln out a LIST of Task names
    the names are used to fill the CheckBox to select a task
 ReportProgress reports Back the current progress of the task

  ProcessTaskF0 :function : Integer;
  ProcessTaskF1 :function(DataIn: Integer) : Integer;
  ProcessTaskF2 :function(DataIn: Integer;DataIn2:Double) : Integer;
  ProcessTaskP1 :function(var DataIn: Integer) : Integer;
  ProcessTaskP2 :function(var DataIn: Integer;DataIn2:Double) : Integer;
  ShowForm: TDLLFunction;
  }
(*   THIS app units:
  VRTaskDroneFrm in 'VRTaskDroneFrm.pas' {VRTaskDroneForm},
  vrrRemConMessages in '..\..\common\vrrRemConMessages.pas',
  VrTaskDronePOFFrm in 'VrTaskDronePOFFrm.pas' {VRTaskDronePOFForm},
  VrTaskDroneAboutFrm in 'VrTaskDroneAboutFrm.pas' {VrTaskDroneAboutForm};
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs,  StdCtrls,
  vrrRemConMessages,
  IdBaseComponent, IdComponent, IdTCPServer, IdSocketHandle,
  ExtCtrls, Menus, Buttons, ComCtrls;

type
  TVRTaskDroneForm = class(TForm)
    IdTCPDrone: TIdTCPServer;
    btnStart: TButton;
    btnExit: TButton;
    Label1: TLabel;
    DroneLabel: TLabel;
    TaskLabel: TLabel;
    Label2: TLabel;
    ProgressLabel: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    edtDroneIP: TEdit;
    Label8: TLabel;
    edtDronePort: TEdit;
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    Options1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    About1: TMenuItem;
    SpeedButton2: TSpeedButton;
    Help1: TMenuItem;
    Label6: TLabel;
    CpuSpeedLabel: TLabel;
    CpuUseLabel: TLabel;
    CpuTimer: TTimer;
    PluginListBox: TListBox;
    Memo1: TRichEdit;
    ListBox1: TListBox;
    Label9: TLabel;
    DroneTask: TLabel;
    ListBox2: TListBox;
    TimerToggle: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnExitClick(Sender: TObject);
    procedure Options1Click(Sender: TObject);
        
    procedure edtDroneIPKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edtDronePortKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure About1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);

    procedure CpuTimerTimer(Sender: TObject);
    procedure TimerToggleClick(Sender: TObject);
function GetCPUSpeed: Double;
    
    procedure btnStartClick(Sender: TObject);

    procedure IdTCPDroneExecute(AThread: TIdPeerThread);
procedure ProcessMessages(MessageID:Integer);
procedure RunProgram;
procedure SetCaptions;
procedure ProcessTask;
procedure FakeProcessTask;
    procedure Timer1Timer(Sender: TObject);
procedure WantProgress;
    procedure FormActivate(Sender: TObject);
    procedure PluginListBoxClick(Sender: TObject);
procedure DetermineTasksAvailable(Selected:Integer);
    {procedure ServerTypeRG1Click(Sender: TObject);}


  private
    { Private declarations }
    Canceled, Finished, Error:Boolean;
    DLLHandleCount: Integer;
    DLLInstanceHandle: THandle;
    TasksAvailable,
    TaskProgress,    ErrorID    :Integer;
    TaskInfoFinishTime:TDateTime;
    ErrorInfo:String;
  public
    { Public declarations }
    TaskInfo: TTaskInfo;
procedure ResetDirectoriesDefaults;
procedure DoLoader;
procedure SetPreferences;
procedure DoSaver;
procedure GetPreferences;
{procedure DoMessages(Input:Integer); }
  end;


var
  VRTaskDroneForm: TVRTaskDroneForm;

type
  PrefRecord = record
    PFractalDir: string[255];
    PProLoaded: string[255];
  PILHallIPPort,  PProgramPort,
  PImageIPPort,PLocatableIPPort,PHolographicsIPPort,
  PFractal3DIPPort, PLifeIPPort ,PVOICEIPPort ,PTracerIPPort ,
  PDTMIPPort ,PGripIceIPPort,PSOSMAPIPPort,PVRGISIPPort,PNoNameIPPort,

    PHolographicsPath,PLocatablePath,PImagePath,
  PILHallPath, PLifePath, PFractal3DPath, PDTMPath,
  PGripPath, PTracerPath,  PVOICEPath,
  PSOSMAPPath, PNoNamePath, PVRGISPath,
  {This is my secret string ? as text?}
    PHiddenString: string[255]; {array [1..256] of Char;}
    PColorreg: Integer;
    PStarted: TDateTime;
    PStartedNameNumber: string[25];
  {X Y Location of forms}
    PMainfrmX, PMainfrmY,
      PAboutX, PAboutY,
      PPOFFormX, PPOFFormY: Integer;
  end;

  PrefFile = file of PrefRecord;
var
  PreRcd: PrefRecord;
  Colorreg: Integer;
  Started: TDateTime;
  StartedNameNumber: string;
  MainfrmX, MainfrmY,
    AboutX, AboutY,
    POFFormX, POFFormY    : Integer;

var
ProjectPath, MapsPath, DemPath,  HTFPath,
ImageryPath, ShapePath, VRMDatabase,
DLGPath, DXFPath, TigerPath,  DotPath,SDTSPath,
  ProjectName, TempName, ProgramPath,
VRMProgramPath, MapName,   VectorPath,

  ILHallIPPort, ProgramPort,
  ImageIPPort,LocatableIPPort,HolographicsIPPort,
  Fractal3DIPPort, LifeIPPort ,VOICEIPPort ,TracerIPPort ,
  DTMIPPort ,GripIceIPPort,SOSMAPIPPort,VRGISIPPort,NoNameIPPort,

ThumbPath,  TransSearchDir,
HolographicsPath,LocatablePath,ImagePath,
  ILHallPath, LifePath, Fractal3DPath, DTMPath, GripPath, TracerPath,
 VOICEPath, SOSMAPPath, NoNamePath, VRGISPath  : string;

var  { GlsDLLDescriptionList,GlsDLLCopyrightList,}
  GlsDLLList: TStringList;
type TDLLFunction = function: integer; stdcall;
 {dll Version tags  .. Requires doing the .res  yourself}
{const IDS_PLUGINNAME = 0;
      IDS_COPYRIGHT = 1;
      IDS_DESCRIPTION = 2;}
{var
  MMSysHandle: THandle;
  PlaySound: function(lpszSoundName: PAnsiChar; uFlags: UINT): BOOL;
  stdcall;}

implementation

uses VRTaskDronePOFFrm, VrTaskDroneAboutFrm, zadCpuUsage;

{$R *.DFM}

procedure TVRTaskDroneForm.FormCreate(Sender: TObject);
begin
  DoLoader;
  left := MainfrmX;
  top := MainfrmY;
  DLLHandleCount :=0;
  TaskProgress:=0;
  ErrorID:=0;
  ErrorInfo:='';
  Error:=False;
  Finished:=False;
  Canceled:=False;
  ProjectPath := ExtractFilePath(ParamStr(0));
  edtDroneIP.Text:=Copy(ProgramPort,1,pos(':',ProgramPort)-1);
  edtDronePort.Text:=Copy(ProgramPort,pos(':',ProgramPort)+1,length(ProgramPort));
end;
procedure TVRTaskDroneForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if IdTCPDrone.active then IdTCPDrone.active := false;
  If DLLHandleCount >0 then   FreeLibrary(DLLInstanceHandle);//FreeLibrary(Handle);
  MainfrmX := VRTaskDroneForm.left;
  MainfrmY := VRTaskDroneForm.top;
  DoSaver;
end;
procedure TVRTaskDroneForm.btnExitClick(Sender: TObject);
begin
  close;
end;

procedure TVRTaskDroneForm.FormActivate(Sender: TObject);
var
  ASearchRec: TSearchRec;
  i:Integer;
{    DLLInstance: THandle;
    DLLName: string;
    DLLCopyright: string;
    DLLDescription: string;}
begin
  PluginListBox.Clear;
  GlsDLLList.Clear;
  {GlsDLLDescriptionList.Clear;
  GlsDLLCopyrightList.Clear;}
  Memo1.Text:=''; //Memo1.Clear;
  TasksAvailable:=0;
  if FindFirst(ExtractFilePath(Application.ExeName) + '*.dll', faArchive, ASearchRec) = 0 then
  begin
    repeat
      If (   {Even NOT sorted they get found alphabetically}
            (ExtractFileName(ASearchRec.Name)='Geographic.dll')or
            (ExtractFileName(ASearchRec.Name)='Information.dll')or
            (ExtractFileName(ASearchRec.Name)='Raster.dll')or
            (ExtractFileName(ASearchRec.Name)='Synthesis.dll')or
            (ExtractFileName(ASearchRec.Name)='Vector.dll')or
            (ExtractFileName(ASearchRec.Name)='VrgisDll.dll')  ) then
      begin
      GlsDLLList.Add(ExtractFilePath(Application.ExeName) + ASearchRec.Name);
      PluginListBox.Items.Add(trim( ASearchRec.Name));
        {Only Keep dll's that are for TReal Vrgis Drone}
{      DLLInstance := LoadLibrary(PChar(ExtractFilePath(Application.ExeName)  + ASearchRec.Name));
      if DLLInstance = 0 then MessageDlg('Error loading the DLL ' + ASearchRec.Name, mtError, [mbOK], 0)
      else
      begin
        SetLength(DLLName, 100);
        SetLength(DLLCopyright, 100);
        SetLength(DLLDescription, 100);
        LoadString(DLLInstance, IDS_PLUGINNAME, PChar(DLLName), Length(DLLName));
        LoadString(DLLInstance, IDS_COPYRIGHT, PChar(DLLCopyright), Length(DLLCopyright));
        LoadString(DLLInstance, IDS_DESCRIPTION, PChar(DLLDescription), Length(DLLDescription));
        If Pos('TReal',DLLDescription)>0 then
        begin
          PluginListBox.Items.Add(trim(DLLName));
          CopyrightLabel.Caption := trim(DLLCopyright);
          GlsDLLCopyrightList.Add(trim(DLLCopyright));
          DescriptionLabel.Caption := trim(DLLDescription);
          GlsDLLDescriptionList.Add(trim(DLLDescription));
        end else
        begin
        showmessage(DLLDescription);
        GlsDLLList.Delete(GlsDLLList.Count-1);
        end;
      end;
      FreeLibrary(DLLInstance);}
      end else showmessage(ASearchRec.Name+ ' not one of mine');
    until FindNext(ASearchRec) <> 0;
    FindClose(ASearchRec);
    If GlsDLLList.Count>0 then PluginListBox.ItemIndex := 0;
    {SetLength(DLLName, 0);
    SetLength(DLLCopyright, 0);
    SetLength(DLLDescription, 0);}
  end
  else MessageDlg('No plugins available...', mtInformation, [mbOK], 0);
  Application.ProcessMessages;
  CollectCPUData; // Get the data for all processors
  For I:= 1 to 2 do
     begin
      CpuSpeedLabel.Caption := Format('%f MHz', [GetCPUSpeed]);
      Application.ProcessMessages;
    end;
end;

procedure TVRTaskDroneForm.PluginListBoxClick(Sender: TObject);
var  i: Integer;
begin
  for i := 0 to (PluginListBox.Items.Count - 1) do
  begin
    try
      if PluginListBox.Selected[i] then
      begin
        {CopyrightLabel.Caption := GlsDLLCopyrightList[i];
        DescriptionLabel.Caption := GlsDLLDescriptionList[i]; }
        {Fill List with Tasks}
        DetermineTasksAvailable(i);
      end
     finally
     { do something here }
     end;
  end;
end;
procedure TVRTaskDroneForm.DetermineTasksAvailable(Selected:Integer);
var
  DllCountin :function : Integer;
  Handle, //  DLLHandleCount
  i:Integer;
Begin
  {Vector.dll}{Raster}{Geographic }{Information }{Synthesis}
  {Find ALL COMPATABLE dll's and get their
  Verification Number.. to verify ok to go on...
  Drone Dll ID        1.1.1.Name[16]
  TaskInfo.ClientID NAME !
  Number of Tasks     xx.xx.xx.16x = 25 char string
  Drone Task Number ID  .. 99 balloons
    Name of Task  .. place in the memo}
  If FileExists(GlsDLLList[Selected])
      {ProjectPath+SwitchString+'.dll')} then
  begin
        Handle := LoadLibrary(PChar(GlsDLLList[Selected]{ProjectPath+SwitchString+'.dll'}));
        if Handle <> 0 then
        begin
          @DllCountin := GetProcAddress(Handle, 'DllCount');
          if @DllCountin <> nil then
          begin    {Tasks Total}
            {TasksAvailable:=TasksAvailable+DllCountin;}
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
  Memo1.Text:='';
                                 {ProjectPath+SwitchString+}
            {showmessage(ChangeFileExt(GlsDLLList[Selected],'.txt'));}
            Memo1.Lines.LoadFromFile(ChangeFileExt(GlsDLLList[Selected],'.txt'));
  Memo1.PasteFromClipboard;
  Memo1.SetFocus;
  ListBox1.Visible:=True;
  ListBox2.Visible:=True;
  ListBox1.Clear;
  ListBox2.Clear;
  ListBox1.items:=Memo1.Lines;
  For i := 1 to ListBox1.items.Count-1 do
     If ListBox1.items[i]=ListBox1.items[i-1] then
     ListBox1.items[i-1]:='';
  For i := 0 to ListBox1.items.Count-1 do
     If ListBox1.items[i]<>'' then
     ListBox2.items.add(ListBox1.items[i]);
  Memo1.Lines:=ListBox2.items;
  ListBox2.Clear;
  ListBox1.Clear;
    ListBox1.Visible:=False;
    ListBox2.Visible:=False;
          end;
          FreeLibrary(Handle);
        end
        else
        begin
        FreeLibrary(Handle);
        end;
  end else showmessage(ChangeFileExt(GlsDLLList[Selected],'.txt') );
  TasksAvailable:=Memo1.Lines.Count;
  TaskLabel.Caption:=Inttostr(TasksAvailable)+' Tasks Available';
End;

procedure TVRTaskDroneForm.Options1Click(Sender: TObject);
begin
  VRTaskDronePOFForm.ShowModal;
end;
procedure TVRTaskDroneForm.Help1Click(Sender: TObject);
begin
  Showmessage('See VR GIS for Help');
end;
procedure TVRTaskDroneForm.About1Click(Sender: TObject);
begin
  VrTaskDroneAboutForm := TVrTaskDroneAboutForm.Create(Self);
  VrTaskDroneAboutForm.ShowModal;
end;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
procedure TVRTaskDroneForm.ResetDirectoriesDefaults;
var IPString:String;
Begin
  VRMProgramPath := ExtractFilePath(ParamStr(0));
  Fractal3DPath:=VRMProgramPath;
  LifePath:=VRMProgramPath;
  SOSMAPPath:=VRMProgramPath;
  VRMProgramPath:=VRMProgramPath;
  TracerPath:=VRMProgramPath;
  VRGISPath:=VRMProgramPath;
  DTMPath:=VRMProgramPath;
  GripPath:=VRMProgramPath;
  ILHallPath:=VRMProgramPath;
  ImagePath:=VRMProgramPath;
  LocatablePath:=VRMProgramPath;
  HolographicsPath:=VRMProgramPath;
  VOICEPath:=VRMProgramPath;
  NoNamePath:=VRMProgramPath;
  ProjectName:=VRMProgramPath;
  MapName:=VRMProgramPath;

  ProjectPath := ExtractFilePath(ParamStr(0));
  ProjectPath := ProjectPath;
  ImagePath := ProjectPath;
  TigerPath := ProjectPath;
  MapsPath:=ProjectPath;
  DemPath := ProjectPath;
  HTFPath := ProjectPath;
  DLGPath := ProjectPath;
  DXFPath := ProjectPath;
  ShapePath := ProjectPath;
  VRMDatabase:= ProjectPath;
  ThumbPath:=ProjectPath;
  IPString:='169.254.126.99:2345';
  ILHallIPPort:=IPString;
  ImageIPPort:=IPString;
  LocatableIPPort:=IPString;
  HolographicsIPPort:=IPString;
  Fractal3DIPPort:=IPString;
   LifeIPPort :=IPString;
   VOICEIPPort :=IPString;
  TracerIPPort :=IPString;
  DTMIPPort :=IPString;
  GripIceIPPort:=IPString;
  SOSMAPIPPort:=IPString;
  VRGISIPPort:=IPString;
  NoNameIPPort:=IPString;
  ProgramPort:=IPString;
  edtDroneIP.Text:=Copy(ProgramPort,1,pos(':',ProgramPort)-1);
  edtDronePort.Text:=Copy(ProgramPort,pos(':',ProgramPort)+1,length(ProgramPort));
    MainfrmX:=123; MainfrmY:=123;
    AboutX:=123; AboutY:=123;
    POFFormX:=123; POFFormY:=123;
End;
{procedure TaGripServFrm.DoMessages(Input:Integer);
Begin

End;}

procedure TVRTaskDroneForm.DoLoader;
var P_File: PrefFile;
var PathS: string;
begin
  PathS := ExtractFilePath(ParamStr(0)) + 'VrTaskDrone.pof';
  if FileExists(PathS) then
  begin
    AssignFile(P_File, PathS);
    Reset(P_File);
    if IoResult <> 0 then
    begin
      CloseFile(P_File);
      ResetDirectoriesDefaults;
      DoSaver;
    end else
    begin
      Read(P_File, PreRcd);
      CloseFile(P_File);
      SetPreferences;
    end;
  end else
  begin
    ResetDirectoriesDefaults;
    DoSaver;
  end;
end;


procedure TVRTaskDroneForm.SetPreferences;
begin {after loading}
  with PreRcd do begin
    Started := PStarted;
    StartedNameNumber := PStartedNameNumber;
    Colorreg := PColorreg;
    MainfrmX := PMainfrmX; MainfrmY := PMainfrmY;
    AboutY := PAboutY; AboutX := PAboutX;
    POFFormX := PPOFFormX;
    POFFormY := PPOFFormY;
  ILHallPath:=PILHallPath;
  HolographicsPath:=PHolographicsPath;
  LocatablePath:=PLocatablePath;
  ImagePath:=PImagePath;
  LifePath:=PLifePath;
  Fractal3DPath:=PFractal3DPath;
  DTMPath:=PDTMPath;
  GripPath:=PGripPath;
  TracerPath:=PTracerPath;
  SOSMAPPath:=PSOSMAPPath;
  NoNamePath:=PNoNamePath;
  VRGISPath:=PVRGISPath;
  VOICEPath:=PVOICEPath;

  ILHallIPPort:=PILHallIPPort;
  ImageIPPort:=PImageIPPort;
  LocatableIPPort:=PLocatableIPPort;
  HolographicsIPPort:=PHolographicsIPPort;
  Fractal3DIPPort:=PFractal3DIPPort;
  LifeIPPort :=PLifeIPPort;
  VOICEIPPort :=PVOICEIPPort;
  TracerIPPort :=PTracerIPPort;
  DTMIPPort :=PDTMIPPort;
  GripIceIPPort:=PGripIceIPPort;
  SOSMAPIPPort:=PSOSMAPIPPort;
  VRGISIPPort:=PVRGISIPPort;
  NoNameIPPort:=PNoNameIPPort;
  ProgramPort:=PProgramPort;
  edtDroneIP.Text:=Copy(ProgramPort,1,pos(':',ProgramPort)-1);
  edtDronePort.Text:=Copy(ProgramPort,pos(':',ProgramPort)+1,length(ProgramPort));
  end;
end;
{---------------------------------------------------------------------}

procedure TVRTaskDroneForm.DoSaver;
var P_File: PrefFile;
var PathS: string;
begin
  PathS := ExtractFilePath(ParamStr(0)) + 'VrTaskDrone.pof';
  GetPreferences;
  AssignFile(P_File, PathS );
  Rewrite(P_File);
  if IoResult <> 0 then
  begin
    ShowMessage('Failed writing VrTaskDrone.pof File');
  end;
  write(P_File, PreRcd);
  CloseFile(P_File);
end;
{---------------------------------------------------------------------}

procedure TVRTaskDroneForm.GetPreferences;
begin {before saving}
  with PreRcd do begin
{This is my secret string ? as text?}
    PHiddenString := 'VrTaskDrone Copyright, 2004: Ivan Lee Herring';
    PColorreg := Colorreg;
    PStarted := Started;
    PStartedNameNumber := StartedNameNumber;
    PMainfrmX := MainfrmX; PMainfrmY := MainfrmY;
    PAboutX := AboutX; PAboutY := AboutY;
    PPOFFormX := POFFormX; PPOFFormY := POFFormY;
  PILHallPath:=ILHallPath;
  PHolographicsPath:=HolographicsPath;
  PLocatablePath:=LocatablePath;
  PImagePath:=ImagePath;
  PLifePath:=LifePath;
  PFractal3DPath:=Fractal3DPath;
  PDTMPath:=DTMPath;
  PGripPath:=GripPath;
  PTracerPath:=TracerPath;
  PSOSMAPPath:=SOSMAPPath;
  PNoNamePath:=NoNamePath;
  PVRGISPath:=VRGISPath;
  PVOICEPath:=VOICEPath;
  PILHallIPPort:=ILHallIPPort;
  PImageIPPort:=ImageIPPort;
  PLocatableIPPort:=LocatableIPPort;
  PHolographicsIPPort:=HolographicsIPPort;
  PFractal3DIPPort:=Fractal3DIPPort;
  PLifeIPPort :=LifeIPPort;
  PVOICEIPPort :=VOICEIPPort;
  PTracerIPPort :=TracerIPPort;
  PDTMIPPort :=DTMIPPort;
  PGripIceIPPort:=GripIceIPPort;
  PSOSMAPIPPort:=SOSMAPIPPort;
  PVRGISIPPort:=VRGISIPPort;
  PNoNameIPPort:=NoNameIPPort;
{  edtServerIP.Text:=Copy(ProgramPort,1,pos(':')-1);
  edtServerPort.Text:=Copy(ProgramPort,pos(':'),length(IPString));}
  ProgramPort:= edtDroneIP.Text+':'+ edtDronePort.Text;
  PProgramPort:=ProgramPort;
  end;
end;
{---------------------------------------------------------------------}
procedure TVRTaskDroneForm.edtDroneIPKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (ssCtrl in Shift)and ((Chr(Key)='v') or (Chr(Key)='V'))
      then edtDroneIP.PasteFromClipboard else
  if (ssCtrl in Shift)and ((Chr(Key)='c') or (Chr(Key)='C'))
      then edtDroneIP.CopyToClipboard;
end;

procedure TVRTaskDroneForm.edtDronePortKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (ssCtrl in Shift)and ((Chr(Key)='v') or (Chr(Key)='V'))
      then edtDronePort.PasteFromClipboard else
  if (ssCtrl in Shift)and ((Chr(Key)='c') or (Chr(Key)='C'))
      then edtDronePort.CopyToClipboard;
end;

{---------------------------------------------------------------------}
procedure TVRTaskDroneForm.TimerToggleClick(Sender: TObject);
begin
  CpuTimer.Enabled:=TimerToggle.Checked;
  If CpuTimer.Enabled then
  begin
   { it will Collect CPU data and Post to form every so often}
  end else
  begin
    CpuUseLabel.Caption:='<Not Set>';
  end;
end;

function TVRTaskDroneForm.GetCPUSpeed: Double;
const
  DelayTime = 500; // measure time in ms
var
  TimerHi, TimerLo: DWORD;
  PriorityClass, Priority: Integer;
begin
  PriorityClass := GetPriorityClass(GetCurrentProcess);
  Priority := GetThreadPriority(GetCurrentThread);
  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);
  Sleep(10);
  asm
    dw 310Fh // rdtsc
    mov TimerLo, eax
    mov TimerHi, edx
  end;
  Sleep(DelayTime);
  asm
    dw 310Fh // rdtsc
    sub eax, TimerLo
    sbb edx, TimerHi
    mov TimerLo, eax
    mov TimerHi, edx
  end;
  SetThreadPriority(GetCurrentThread, Priority);
  SetPriorityClass(GetCurrentProcess, PriorityClass);
  Result := TimerLo / (1000.0 * DelayTime);
end;

procedure TVRTaskDroneForm.CpuTimerTimer(Sender: TObject);
var i: Integer;
begin
  CollectCPUData; // Get the data for all processors
  for i:=0 to GetCPUCount-1 do // Show data for each processor
        CpuUseLabel.Caption:=Format('CPU #%d - %5.2f%%',[i,GetCPUUsage(i)*100]);
end;


procedure TVRTaskDroneForm.btnStartClick(Sender: TObject);
var
  i:Integer;
  Binding : TIdSocketHandle;
  {forgot what these are 169.254.126.198:2345,  127.0.0.1:9999}
begin
  For I:= 1 to 3{10} do  {? makes for a Definite LAG time}
  begin
      CpuSpeedLabel.Caption := Format('%f MHz', [GetCPUSpeed]);
      Application.ProcessMessages;
  end;
  Binding := IdTCPDrone.Bindings.Add;
  Binding.Port:=StrToInt(edtDronePort.Text);
  Binding.IP := edtDroneIP.Text;
  {Binding determine IP Address Port 127.0.0.1:xxxx  self}
  IdTCPDrone.active := not IdTCPDrone.active;
  if btnStart.caption = 'Start' then btnStart.caption := 'Stop'
  else if btnStart.caption = 'Stop' then btnStart.caption := 'Start';
  {Freeze selections}
   edtDroneIP.Enabled := not IdTCPDrone.active;
   edtDronePort.Enabled := not IdTCPDrone.active;
   {Done on form initialization
   DetermineTasksAvailable(IdTCPDrone.active);}
end;



procedure TVRTaskDroneForm.IdTCPDroneExecute(AThread: TIdPeerThread);
var
  I, MessageID      : integer; //cardinal;
begin
  AThread.connection.ReadBuffer(TaskInfo,SizeOf(TaskInfo));
  MessageID:=TaskInfo.Msg;
  case MessageID of
    C2S_MSG_FirstConnect:
    begin
      TaskInfo.Msg:=S2C_MSG_AccountValid;
      AThread.Connection.WriteBuffer(TaskInfo, SizeOf(TaskInfo));
    end;
    C2S_MSG_WantConnection    :  {This serves as a Server CPU capacity}
    begin
      TaskInfo.Msg:=S2C_MSG_Connected;
      TaskInfo.FinishTime:= GetCPUSpeed;
      {What and HOW MANY tasks are available - Capable ? }
      {Change this to ID each DLL for USE  Each Dll MUST have its OWN ID ..99 max}
      TaskInfo.ClientID:=0;
      TaskInfo.TaskID:=TasksAvailable;
      AThread.Connection.WriteBuffer(TaskInfo, SizeOf(TaskInfo));
      {Dunno what the True does...
            AThread.connection.WriteBuffer(TaskInfo,SizeOf(TaskInfo),true);}
      for i:=0 to  TasksAvailable-1 do
      AThread.connection.WriteLn(Memo1.Lines[i]);
    end;
   C2S_MSG_WantUsage:
    begin
      TaskInfo.Msg:=S2C_MSG_WantUsage;
      { for THIS DRONE }
      CollectCPUData;
      TaskInfo.TaskData2 :=GetCPUUsage(0);
      AThread.Connection.WriteBuffer(TaskInfo, SizeOf(TaskInfo));
    end;
    C2S_MSG_WantDisconnection :
    begin
      {Cancel the App if running}
      Canceled:=True;
      //message info "bye"
      TaskInfo.Msg:=S2C_MSG_DisConnected;
      AThread.Connection.WriteBuffer(TaskInfo, SizeOf(TaskInfo));
      //disconnect the client
      AThread.Connection.DisconnectSocket;
      {Reset the Start Stop ? to "Clear" things }
    end;
    C2S_MSG_Task:
    begin
      TaskInfo.Msg:=S2C_MSG_Task;
      TaskInfo.ProgressID:=TaskProgress;{0 at create}
      TaskInfo.StartTime:=Now;
      TaskInfo.FinishTime :=Now;{Clears CPU test}
      AThread.Connection.WriteBuffer(TaskInfo, SizeOf(TaskInfo));
      ProcessMessages(MessageID);
    end;
    C2S_MSG_WantProgress:
    begin
      WantProgress;
      If Error then
      begin
        TaskInfo.Msg:=S2C_MSG_Error;
        TaskInfo.ErrorID :=ErrorID;
        TaskInfo.ErrorInfo :=ErrorInfo;
      end else
      If Finished then
      begin
        TaskInfo.Msg:=S2C_MSG_Finished;
        TaskInfo.FinishTime :=TaskInfoFinishTime;
      end else
      If TaskProgress < 100 then
      begin
        TaskInfo.Msg:=S2C_MSG_Progress;
        TaskInfo.ProgressID:=TaskProgress;
      end;
      AThread.Connection.WriteBuffer(TaskInfo, SizeOf(TaskInfo));
    end;
  end;
end;


procedure TVRTaskDroneForm.ProcessMessages(MessageID:Integer);
Begin
  Timer1.Enabled:=True; {Maybe just do some Application.ProcessMessages}
End;
procedure TVRTaskDroneForm.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=False; {Time tunnel transfer: 1 second delay}
  RunProgram;
end;

procedure TVRTaskDroneForm.RunProgram;
Begin
  TaskProgress:=0;
  ErrorID:=0;
  ErrorInfo:='';
  Error:=False;
  Finished:=False;
  Canceled:=False;
  SetCaptions;
  ProcessTask;
end;

procedure TVRTaskDroneForm.SetCaptions;
Begin   {Either decipher the string or Keep making Case changes}
  {Gather from INCOMING  TaskInfo.ClientID to Determine
  WHAT was Selected as THE TASK and the DLL ClientLabel}
  { TaskLabel.Caption:=Memo1.Lines[TaskInfo.ClientID];
    DroneLabel.Caption:=}
  Case TaskInfo.ClientID of
  1:begin
      DroneLabel.Caption:='Vector';
      Case TaskInfo.TaskID of
      1: DroneTask.Caption:='ProcessMap';
      end;
    end;
  2: begin
      DroneLabel.Caption:='Raster';
      Case TaskInfo.TaskID of
      1: DroneTask.Caption:='ProcessFormat';
      end;
    end;
  3: begin
      DroneLabel.Caption:='Geographic';
      Case TaskInfo.TaskID of
      1: DroneTask.Caption:='Prime';
      2: DroneTask.Caption:='PrimeIn';
      3: DroneTask.Caption:='PrimeVerified';
      4: DroneTask.Caption:='ProcessTpcfg';
      5: DroneTask.Caption:='SrtmDefrag';
      6: DroneTask.Caption:='ComputeTextures';
      end;
    end;
  4: begin
      DroneLabel.Caption:='Information';
      Case TaskInfo.TaskID of
      1: DroneTask.Caption:='ProcessShape';
      end;
    end;
  5: begin
      DroneLabel.Caption:='Synthesis';
      Case TaskInfo.TaskID of
      1: DroneTask.Caption:='ProcessSynthesis';
      end;
    end;
  6: begin
      DroneLabel.Caption:='VrgisDll';
      Case TaskInfo.TaskID of
      1: DroneTask.Caption:=TaskInfo.Name;
      else DroneTask.Caption:=TaskInfo.Name;
      end;
    end;
  end;
End;

procedure TVRTaskDroneForm.ProcessTask;
var
  aDataIn: Integer;
  aDataIn2:Double;
  aDataInS:String;

  ProcessTaskF0 :function : Integer;
  ProcessTaskF1 :function(DataIn: Integer) : Integer;
  ProcessTaskF2 :function(DataIn: Integer;DataIn2:Double) : Integer;
  ProcessTaskP1 :function(var DataIn: Integer) : Integer;
  ProcessTaskP2 :function(var DataIn: Integer;DataIn2:Double) : Integer;
  ShowForm: TDLLFunction;
  DllNameString,CheckString:String;
Begin
  If DLLHandleCount >0 then   FreeLibrary(DLLInstanceHandle);
  DllNameString:=ExtractFilePath(ParamStr(0))+DroneLabel.Caption+'.dll';
  CheckString:=TaskInfo.Name[length(TaskInfo.Name)-1];
  CheckString:=CheckString+TaskInfo.Name[length(TaskInfo.Name)];
  DLLInstanceHandle := LoadLibrary(PChar(DllNameString));
  {DLLInstanceHandle := LoadLibrary(PChar(GlsDLLList[PluginListBox.ItemIndex]));}
  if DLLInstanceHandle = 0 then
  begin
    MessageDlg('Error loading the DLL ' + PChar(DllNameString),
                mtError, [mbOK], 0);
    FreeLibrary(DLLInstanceHandle);
  end
  else
  begin
    DLLHandleCount :=1;
    If CheckString='F0' then
    begin
      aDataInS:=TaskInfo.Name;
      @ProcessTaskF0 := GetProcAddress(Handle, PChar(aDataInS));
      if @ProcessTaskF0 <> nil then
            TaskInfo.TaskResult:=ProcessTaskF0;
    end else
    If CheckString='F1' then
    begin
        aDataIn:=TaskInfo.TaskData1;
        aDataInS:=TaskInfo.Name;
          @ProcessTaskF1 := GetProcAddress(Handle, PChar(aDataInS));
          if @ProcessTaskF1 <> nil then
            TaskInfo.TaskResult:=ProcessTaskF1(aDataIn);
    end else
    If CheckString='F2' then
    begin
        aDataIn:=TaskInfo.TaskData1;
        aDataIn2:=TaskInfo.TaskData2;
        aDataInS:=TaskInfo.Name;
          @ProcessTaskF2:= GetProcAddress(Handle, PChar(aDataInS));
          if @ProcessTaskF2 <> nil then
            TaskInfo.TaskResult:=ProcessTaskF2(aDataIn,aDataIn2);
    end else
    If CheckString='P1' then
    begin
        aDataIn:=TaskInfo.TaskData1;
        aDataInS:=TaskInfo.Name;
          @ProcessTaskP1 := GetProcAddress(Handle, PChar(aDataInS));
          if @ProcessTaskP1 <> nil then
            TaskInfo.TaskResult:=ProcessTaskP1(aDataIn);
        TaskInfo.TaskData1:=aDataIn;
    end else
    If CheckString='P2' then
    begin
        aDataIn:=TaskInfo.TaskData1;
        aDataIn2:=TaskInfo.TaskData2;
        aDataInS:=TaskInfo.Name;
          @ProcessTaskP2 := GetProcAddress(Handle, PChar(aDataInS));
          if @ProcessTaskP2 <> nil then
            TaskInfo.TaskResult:=ProcessTaskP2(aDataIn,aDataIn2);
        TaskInfo.TaskData1:=aDataIn;
        TaskInfo.TaskData2:=aDataIn2;
    end else
    begin
        aDataInS:=TaskInfo.Name;
        @ShowForm := GetProcAddress(DLLInstanceHandle, PChar(aDataInS));
          if @ShowForm <> nil then
          TaskInfo.TaskResult:=ShowForm;
    end;
  end;
End;



procedure TVRTaskDroneForm.WantProgress;
var
  DoWhat, LocalErrorInfoIn: Integer;
  ReportProgressin :function(var ErrorInfoIn: Integer) : Integer;
  {ErrorInfoString, SwitchString:String;}
Begin
  LocalErrorInfoIn:=0;
  TaskProgress:=-1;
        if DLLInstanceHandle > 0 then
        begin
          @ReportProgressin := GetProcAddress(DLLInstanceHandle, 'ReportProgress');
          if @ReportProgressin <> nil then
          begin
            DoWhat:=ReportProgressin(LocalErrorInfoIn);
            Case DoWhat of
            0..100:begin
                TaskProgress:=DoWhat;
                ProgressLabel.Caption:=inttostr(DoWhat);
              end;
            101:begin
                  Finished:=True;
                  TaskInfoFinishTime :=Now;
              end;
            else
            If DoWhat > 101 then
              begin
                Error:=True;
                ErrorID:=DoWhat;
                {Need to Really get an ErrorString...}

                Case  LocalErrorInfoIn of
                1:ErrorInfo:='Too close to call';
                101:ErrorInfo:='Houston, We have a Problem';
                else ErrorInfo:=Inttostr(LocalErrorInfoIn);
                end;
              end;
            end;{case}
          end;
        end;
End;

procedure TVRTaskDroneForm.FakeProcessTask;
var I:Integer;
Begin
  Repeat
  begin
    For I:= 1 to 100 do
    begin
    Application.ProcessMessages;
      If Canceled then {Close Gracefully ?}exit;
      TaskProgress:=I;
      ProgressLabel.Caption:=inttostr(I);
      Sleep(50);

      If I > 101 then
      begin
        Error:=True;
        exit;
      end;
    end;
    Finished:=True;
    TaskInfoFinishTime :=Now;
  end until Finished;
End;

initialization

GlsDLLList := TStringList.Create;
{GlsDLLDescriptionList:= TStringList.Create;
GlsDLLCopyrightList:= TStringList.Create; }

finalization

GlsDLLList.Free;
{GlsDLLDescriptionList.Free;
GlsDLLCopyrightList.Free;}


end.
