unit VrTaskDroneAboutFrm;
(***************************************************************
 *                                                             *
 *        Image Locatable Holographics      Version 3.0.0.0    *
 *                                                             *
 *        Copyright (C) 1991,2003 by   Tachyon Software, Inc.  *
 *                                                             *
 *                                                             *
{. $IFDEF DO87}
{. $F+,O+,X+,I-}
{. $N+,E-,R-,D-,S-}
{. $B-,A+,W+,L-,V-,G+}
{. $ELSE}
{. $F+,O+,X+,I-}
{. $N-,E-,R-,D-,S-}
{. $B-,A+,W+,L-,V-,G+}
{. $ENDIF}
 ***************************************************************)


interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ShellAPI, ExtCtrls;

type
  TVrTaskDroneAboutForm = class(TForm)
    Panel1: TPanel;
    Version: TLabel;
    Copyright: TLabel;
    Comments: TLabel;
    BuildInfo: TLabel;
    Label3: TLabel;
    Label10: TLabel;
    Label2: TLabel;
    ProgramIcon: TImage;
    Image1: TImage;
    DelphiButton: TSpeedButton;
    Label18: TLabel;
    Label17: TLabel;
    Image2: TImage;
    Image3: TImage;
    procedure FormCreate(Sender: TObject);
    procedure GetBuildInfo(var v1, v2, v3, v4: Word);
    function GetBuildInfoString: string;
    procedure Image1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DelphiButtonClick(Sender: TObject);
    procedure Label18Click(Sender: TObject);
    procedure Label17Click(Sender: TObject);
    procedure ProgramIconClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  VrTaskDroneAboutForm: TVrTaskDroneAboutForm;

implementation
uses VRTaskDroneFrm;
{$R *.DFM}

procedure TVrTaskDroneAboutForm.FormCreate(Sender: TObject);
begin
  left := AboutX;
  top := AboutY;
    BuildInfo.Caption := GetBuildInfoString
end;
procedure TVrTaskDroneAboutForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  AboutX := VrTaskDroneAboutForm.left;
  AboutY := VrTaskDroneAboutForm.top;
    ModalResult := mrOK;
end;
procedure TVrTaskDroneAboutForm.GetBuildInfo(var v1, v2, v3, v4: Word);
var
  VerInfoSize: DWord;
  VerInfo: Pointer;
  VerValueSize: DWord;
  VerValue: PVSFixedFileInfo;
  Dummy: DWord;
begin
  VerInfoSize := GetFileVersionInfoSize(PChar(Application.ExeName),
    dummy);
  GetMem(VerInfo, VerInfoSize);
  GetFileVersionInfo(PChar(Application.ExeName), 0, VerInfoSize,
    VerInfo);
  VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
  with VerValue^ do
  begin
    v1 := dwFileVersionMS shr 16;
    v2 := dwFileVersionMS and $FFFF;
    v3 := dwFileVersionLS shr 16;
    v4 := dwFileVersionLS and $FFFF;
  end;
  FreeMem(VerInfo, VerInfoSize);
end;

function TVrTaskDroneAboutForm.GetBuildInfoString: string;
var
  v1, v2, v3, v4: Word;
begin
  GetBuildInfo(v1, v2, v3, v4);
  Result := Format('%d.%d.%d  (Build %d)', [v1, v2, v3, v4]);
end;

procedure TVrTaskDroneAboutForm.Image1Click(Sender: TObject);
begin
  close;
end;

procedure TVrTaskDroneAboutForm.DelphiButtonClick(Sender: TObject);
begin
  ShellExecute(0, 'open', 'http://www.borland.com/delphi/', '', '',
    SW_SHOW);
end;

procedure TVrTaskDroneAboutForm.Label18Click(Sender: TObject);
begin
  ShellExecute(0, 'open',
    'http://www.ezl.com/~ilh2o/', '', '', SW_SHOW);
end;

procedure TVrTaskDroneAboutForm.Label17Click(Sender: TObject);
begin
  ShellExecute(0, 'open',
    'mailto:ilh2o@ezl.com', 'Subject:Tachyon Unit', '', SW_SHOW);
end;

procedure TVrTaskDroneAboutForm.ProgramIconClick(Sender: TObject);
begin
  ShellExecute(0, 'open',
    'http://www.nevrona.com/indy/', '', '', SW_SHOW);
end;

end.
 
